'From Squeak3.7 of ''4 September 2004'' [latest update: #5989] on 14 July 2008 at 1:58:52 pm'!

!Color class methodsFor: 'colormaps' stamp: 'jmv 7/14/2008 13:31'!
clearAAColormaps
	CachedColormapsForAAText _ nil! !


!Color class methodsFor: 'colormaps' stamp: 'jmv 7/14/2008 13:28'!
computeColormapForAATextColor: foregroundColor depth: destDepth
	| mask map c bitsPerColor r g b f |
	"CachedColormapsForAAText _ nil"
	bitsPerColor _ Preferences aaFontsColormapDepth.
	mask _ (1 bitShift: bitsPerColor) - 1.
	map _ Bitmap new: (1 bitShift: (3 * bitsPerColor)).
	0 to: map size - 1 do: [:i |
		r _ (i bitShift: 0 - (2 * bitsPerColor)) bitAnd: mask.
		g _ (i bitShift: 0 - bitsPerColor) bitAnd: mask.
		b _ (i bitShift: 0) bitAnd: mask.
		f _ 1.0 - (r + g + b / 3.0 / mask).
		c _ foregroundColor * f alpha: f.
		map at: i + 1 put: (c pixelValueForDepth: destDepth)].
	^ map! !


!Preferences class methodsFor: 'standard queries' stamp: 'jmv 7/14/2008 13:27'!
aaFontsColormapDepth
	^ self
		valueOfFlag: #aaFontsColormapDepth
		ifAbsent: [3]! !

